#!/usr/bin/perl

use strict;
use warnings;

my $infile = shift;
my $offset_diff = shift;

if (! $infile) {
    die "Usage: fix_marks.pl  marks.vdr offset_diff";
}

open FH, $infile || die "$!\n";

my @marks = <FH>;
close FH;

my @frames;
my @correct_marks;

foreach (@marks)  {
    push @frames, mark2frames($_);
}

my $framediff = ticks2frames($offset_diff);


open OF, ">./correct_marks.vdr" || die "$!\n";

foreach (@frames) {
    push @correct_marks, (frames2mark($_ - $framediff));
    print OF (frames2mark($_ - $framediff)) ." \n";
    print "corrected mark: " .(frames2mark($_ - $framediff)) ."\n";
}

close OF;









sub mark2frames{
	my $mark = shift;
	my($h, $m, $s, $f) = split /[:.]/, $mark;
	my $frame = (3600 * $h + 60 * $m + $s) * 25 + $f ;
	return $frame;
};

sub frames2mark {
	my $now = shift;
	print "now is $now\n";
	my $rest = $now  % 25;
	my $full_secs = int ($now  * 0.04);
	
	my $h = int($full_secs/3600);
	my $min = int(($full_secs - (3600 * $h)) / 60);
	my $sec = $full_secs - (3600 * $h + 60 * $min);
	return sprintf "%1u:%02u:%02u.%02u", $h, $min, $sec, $rest;
};

sub ticks2frames {
    my $ticks = shift;
    return $ticks / 3600;
}
